#!/bin/sh
CHIPTOOLS=rkbin
VENDORMODEL=odroid-n1
#VENDORMODEL=rock-pi-4a
#VENDORMODEL=rock-pi-4b
#VENDORMODEL=rock960-ab
#VENDORMODEL=rock960-c
#VENDORMODEL=rock64
#VENDORMODEL=rockpro64
#VENDORMODEL=pinebook-pro
#VENDORMODEL=evb
XYPRONTAG=2018.03
TAG=2017.09
RELNAME=snapshot-20191031

TAGYEARS=`expr ${TAG:0:4} \* 416`
TAGMONTH=`expr ${TAG:5:2} \* 32`
TAGSTAMP=`expr ${TAGYEARS} + ${TAGMONTH}`

REVISION=`echo ${RELNAME} | cut -d '-' -f 2`

REVYEARS=`expr ${REVISION:0:4} \* 416`
REVMONTH=`expr ${REVISION:4:2} \* 32`
REVMDAYS=${REVISION:6:2}
REVSTAMP=`expr ${REVYEARS} + ${REVMONTH} + ${REVMDAYS}`

REVISION=`expr ${REVSTAMP} - ${TAGSTAMP}`

mkdir -p u-boot-source
cd u-boot-source

test -d u-boot-build || git clone -b v${XYPRONTAG} https://github.com/xypron/u-boot-odroid-c2 u-boot-build

test -d denx || git clone -v -b next-dev https://github.com/rockchip-linux/u-boot denx
test -d ${CHIPTOOLS} || git clone -v -b stable-4.4-rk3399-linux https://github.com/rockchip-linux/${CHIPTOOLS} ${CHIPTOOLS}
 
cd ..

if [ ! -e u-boot-${TAG}-${RELNAME}-git-source.tar.gz ]; then
  echo "Packing u-boot-${TAG}-${RELNAME}-git-source..."

  tar czf u-boot-${TAG}-${RELNAME}-git-source.tar.gz u-boot-source
fi

echo "Preparing u-boot-${VENDORMODEL}..."

mkdir u-boot-${VENDORMODEL}
cp -apP u-boot-source/u-boot-build/. u-boot-${VENDORMODEL}/
cp -apP u-boot-source/denx u-boot-${VENDORMODEL}/
cp -apP u-boot-source/${CHIPTOOLS} u-boot-${VENDORMODEL}/

cd u-boot-${VENDORMODEL}

patch -p1 < ../u-boot-odroidn1-makefile.patch
#patch -p1 < ../u-boot-odroidn1-makefile-part2.patch
#patch -p1 < ../u-boot-odroidn1-makefile-2017_07.patch
#patch -p1 < ../u-boot-odroidn1-makefile-release-20170901.patch
#patch -p1 < ../u-boot-odroidn1-makefile-release-20171107.patch
#patch -p1 < ../u-boot-odroidn1-makefile-release-20171218.patch

# 20190125
#patch -p1 < ../u-boot-odroidn1-makefile-commit-524f264.patch

# 20190430
#patch -p1 < ../u-boot-odroidn1-makefile-commit-94cf109.patch
# 20190517
#patch -p1 < ../u-boot-odroidn1-makefile-commit-01714a2.patch
# 20190527
#patch -p1 < ../u-boot-odroidn1-makefile-commit-2e6f3f4.patch
# 20190529
#patch -p1 < ../u-boot-odroidn1-makefile-commit-ce7f8a1.patch
# 20190531
#patch -p1 < ../u-boot-odroidn1-makefile-commit-ea4b801.patch
# 20190606
#patch -p1 < ../u-boot-odroidn1-makefile-commit-cb0376d.patch
# 20191031
patch -p1 < ../u-boot-odroidn1-makefile-commit-d65bf0c.patch

patch -p1 < ../u-boot-odroidn1-makefile-no-hardkernel.patch

#sed -i s/'arm64'/'armhf'/g build-dpkg.sh 
#sed -i s/'arm64'/'armhf'/g debian/control 
#sed -i s/' ARCH=arm64'/' ARCH=arm'/g Makefile 
#sed -i s/'aarch64-linux-gnu-'/'arm-linux-gnueabihf-'/g Makefile
#sed -i s/'aarch64'/'armv7l'/g Makefile 

sed -i s/2018.01\.001/${TAG}.000/g debian/changelog
sed -i s/2018.01/${TAG}/g debian/changelog

sed -i s/2017.11\.001/2017.07.000/g debian/changelog
sed -i s/2017.11-rc2/2017.07/g debian/changelog
sed -i s/2017.11/2017.07/g debian/changelog

sed -i s/${XYPRONTAG}\.001/${TAG}.${REVISION}/g debian/changelog
sed -i s/${XYPRONTAG}/${TAG}/g debian/changelog

sed -i s/'Heinrich Schuchardt'/'BSP'/g debian/changelog
sed -i s/'xypron.glpk@gmx.de'/'developer@build.local'/g debian/changelog

sed -i s/'^REVISION=.*'/'REVISION='${REVISION}/g Makefile

sed -i s/'odroid-c2'/${VENDORMODEL}/g debian/changelog 
sed -i s/'odroid-c2'/${VENDORMODEL}/g debian/control 

sed -i s/'odroid-c2'/${VENDORMODEL}/g debian/source/options 
sed -i s/meson-tools/${CHIPTOOLS}/g debian/source/options
#sed -i s/hardkernel/sunxi/g debian/source/options

sed -i s/'odroid-c2'/${VENDORMODEL}/g Makefile 
sed -i "s|make fip_create|#make fip_create|g" Makefile
sed -i "s|make sign|#make sign|g" Makefile
sed -i "s|dd if=u-boot.bin of=|#dd if=u-boot.bin of=|g" Makefile
#sed -i "s|hardkernel/sd_fuse/bl1.bin.hardkernel|denx/u-boot-sunxi-with-spl.bin|g" Makefile
sed -i "s|hardkernel/sd_fuse/sd_fusing.sh|patch/sd_fusing.sh|g" Makefile
#sed -i "s|https://github.com/hardkernel/u-boot.git|https://github.com/linux-sunxi/u-boot-sunxi|g" Makefile
sed -i "s|https://github.com/afaerber/meson-tools.git|https://github.com/radxa/${CHIPTOOLS}|g" Makefile
sed -i s/meson-tools/${CHIPTOOLS}/g Makefile
sed -i "/cd ${CHIPTOOLS} && make clean/d" Makefile
#sed -i s/hardkernel/sunxi/g Makefile

#echo 'tar-ignore = "sunxi"' >> debian/source/options

cp -p ../sd_fusing.sh ./patch/
cp -p ../config-${TAG} ./config/

rm -f patch/*.patch
rm -f patch/patch-${TAG}
echo '#!/bin/sh' > patch/patch-${TAG}
chmod ugo+rx patch/patch-${TAG}

cd ..

#echo "Packing u-boot-${TAG}-${RELNAME}-${VENDORMODEL}-source..."

#tar czf u-boot-${TAG}-${RELNAME}-${VENDORMODEL}-source.tar.gz u-boot-${VENDORMODEL}

echo OK
